package dev.shadowsoffire.apotheosis.adventure.affix.augmenting;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.blaze3d.platform.GlStateManager;
import com.mojang.blaze3d.systems.RenderSystem;
import com.mojang.blaze3d.vertex.PoseStack;
import dev.shadowsoffire.apotheosis.adventure.affix.augmenting.AugmentingTableTile;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.MultiBufferSource;
import net.minecraft.client.renderer.Sheets;
import net.minecraft.client.renderer.blockentity.BlockEntityRenderer;
import net.minecraft.client.renderer.entity.ItemRenderer;
import net.minecraft.client.resources.model.BakedModel;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.util.Mth;
import net.minecraft.world.inventory.InventoryMenu;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntity;
import org.joml.Quaternionf;

public class AugmentingTableTileRenderer implements BlockEntityRenderer<AugmentingTableTile> {
  public static final ResourceLocation STAR_CUBE = new ResourceLocation("apotheosis", "item/star_cube");
  
  public void render(AugmentingTableTile tile, float partials, PoseStack matrix, MultiBufferSource pBufferSource, int light, int overlay) {
    float progress, rotation;
    double rise;
    if (tile.stage == AugmentingTableTile.AnimationStage.HIDING)
      return; 
    (Minecraft.m_91087_()).f_90987_.m_118506_(InventoryMenu.f_39692_).m_117960_(false, false);
    RenderSystem.setShaderTexture(0, InventoryMenu.f_39692_);
    RenderSystem.enableBlend();
    RenderSystem.blendFunc(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA);
    RenderSystem.setShaderColor(1.0F, 1.0F, 1.0F, 1.0F);
    ItemRenderer irenderer = Minecraft.m_91087_().m_91291_();
    BakedModel base = irenderer.m_115103_().m_109393_().getModel(STAR_CUBE);
    double px = 0.0625D;
    long time = tile.time;
    matrix.m_85836_();
    matrix.m_85837_(5.0D * px, 5.0D * px, 5.0D * px);
    switch (null.$SwitchMap$dev$shadowsoffire$apotheosis$adventure$affix$augmenting$AugmentingTableTile$AnimationStage[tile.stage.ordinal()]) {
      case 2:
        progress = ((float)time + partials) / AugmentingTableTile.RISE_TIME;
        rise = Mth.m_14139_(progress, 0.1D * px, 11.0D * px);
        matrix.m_85837_(0.0D, rise, 0.0D);
        break;
      case 3:
        progress = ((float)(AugmentingTableTile.RISE_TIME - time) + partials) / AugmentingTableTile.RISE_TIME;
        rise = Mth.m_14139_(progress, 11.0D * px, 0.1D * px);
        matrix.m_85837_(0.0D, rise, 0.0D);
        break;
      case 4:
        rotation = ((float)(time % 360L) + partials) * 3.1415927F / 180.0F;
        matrix.m_85837_(0.0D, 11.0D * px, 0.0D);
        matrix.m_85837_(3.0D * px, 3.0D * px, 3.0D * px);
        matrix.m_252781_((new Quaternionf()).rotationXYZ(rotation, 0.0F, rotation));
        matrix.m_85837_(-3.0D * px, -3.0D * px, -3.0D * px);
        break;
    } 
    irenderer.m_115189_(base, ItemStack.f_41583_, light, overlay, matrix, ItemRenderer.m_115222_(pBufferSource, Sheets.m_110791_(), true, false));
    matrix.m_85849_();
  }
}
